Coin: SoTexture2 Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoTexture2 Class Reference
Node Classes

The SoTexture2 class is used to map a 2D texture onto subsequent geometry in the scene graph. More...

`#include <Inventor/nodes/SoTexture2.h>`

Inheritance diagram for SoTexture2:

## Public Types
enum | Model { MODULATE = SoMultiTextureImageElement::MODULATE , DECAL = SoMultiTextureImageElement::DECAL , BLEND = SoMultiTextureImageElement::BLEND , REPLACE = SoMultiTextureImageElement::REPLACE }
enum | Wrap { REPEAT = SoMultiTextureImageElement::REPEAT , CLAMP = SoMultiTextureImageElement::CLAMP }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }

## Public Member Functions
virtual SoType | getTypeId (void) const
| SoTexture2 (void)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | rayPick (SoRayPickAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SbBool | readImage (const SbString &fname, int &w, int &h, int &nc, unsigned char *&bytes)
Static Public Member Functions inherited from SoTexture
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | cleanupClass (void)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFString | filename
SoSFImage | image
SoSFEnum | wrapS
SoSFEnum | wrapT
SoSFEnum | model
SoSFColor | blendColor
SoSFBool | enableCompressedTexture

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTexture2 ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | notify (SoNotList *list)
int | getReadStatus (void)
void | setReadStatus (int s)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoTexture
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoTexture2 class is used to map a 2D texture onto subsequent geometry in the scene graph.

Shape nodes within the scope of SoTexture2 nodes in the scene graph (i.e. below the same SoSeparator and to the right hand side of the SoTexture2) will have the texture applied according to each shape type's individual characteristics. See the documentation of the various shape types (SoFaceSet, SoCube, SoSphere, etc.) for information about the specifics of how the textures will be applied.

For a simple usage example, see the class documentation for SoSFImage.

One common flaw with many programs that have support for exporting VRML or Inventor files, is that the same texture file is exported several times, but as different nodes. This can cause excessive texture memory usage and slow rendering. Below is an example program that fixes this by replacing all instances of the same texture with a pointer to the first node:

#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTexture2.h>
#include <Inventor/SoDB.h>
#include <Inventor/SoInput.h>
#include <Inventor/SoOutput.h>
int main(int argc, char ** argv)
{
if (argc < 2) return -1;
SoDB::init();
SoInput in;
if (!in.openFile(argv[1])) return -1;
SoSeparator * root = SoDB::readAll(&in);
if (!root) return -1;
root->ref();
SoSearchAction sa;
sa.setType(SoTexture2::getClassTypeId());
sa.setInterest(SoSearchAction::ALL);
sa.setSearchingAll(TRUE);
sa.apply(root);
SoPathList & pl = sa.getPaths();
SbDict namedict;
for (int i = 0; i < pl.getLength(); i++) {
SoFullPath * p = (SoFullPath*) pl[i];
if (p->getTail()->isOfType(SoTexture2::getClassTypeId())) {
SoTexture2 * tex = (SoTexture2*) p->getTail();
if (tex->filename.getValue().getLength()) {
SbName name = tex->filename.getValue().getString();
unsigned long key = (unsigned long) ((void*) name.getString());
void * tmp;
if (!namedict.find(key, tmp)) {
// new texture. just insert into list
(void) namedict.enter(key, tex);
}
else if (tmp != (void*) tex) { // replace with node found in dict
SoGroup * parent = (SoGroup*) p->getNodeFromTail(1);
int idx = p->getIndexFromTail(0);
parent->replaceChild(idx, (SoNode*) tmp);
}
}
}
}
sa.reset();
// output fixed scene to stdout
SoOutput out;
SoWriteAction wa(&out);
wa.apply(root);
root->unref();
}
SbDict
The SbDict class organizes a dictionary of keys and values.
Definition SbDict.h:63
SbDict::enter
SbBool enter(const Key key, void *const value)
Definition SbDict.cpp:165
SbDict::find
SbBool find(const Key key, void *&value) const
Definition SbDict.cpp:176
SbName
The SbName class stores strings by reference.
Definition SbName.h:40
SbName::getString
const char * getString(void) const
Definition SbName.cpp:144
SbPList::getLength
int getLength(void) const
Definition lists/SbPList.h:103
SbString::getLength
int getLength(void) const
Definition SbString.h:76
SbString::getString
const char * getString(void) const
Definition SbString.h:84
SoAction::apply
virtual void apply(SoNode *root)
Definition SoAction.cpp:463
SoBase::unref
void unref(void) const
Definition SoBase.cpp:530
SoBase::isOfType
SbBool isOfType(SoType type) const
Returns TRUE if the type of this object is either of the same type or inherited from type.
Definition SoBase.cpp:631
SoBase::ref
void ref(void) const
Definition SoBase.cpp:478
SoDB::readAll
static SoSeparator * readAll(SoInput *input)
Definition SoDB.cpp:682
SoDB::init
static void init(void)
Definition SoDB.cpp:200
SoFullPath
The SoFullPath class allows examination of hidden children in paths.
Definition SoFullPath.h:38
SoFullPath::getTail
SoNode * getTail(void) const
Definition SoFullPath.cpp:84
SoFullPath::getIndexFromTail
int getIndexFromTail(const int index) const
Definition SoFullPath.cpp:106
SoFullPath::getNodeFromTail
SoNode * getNodeFromTail(const int index) const
Definition SoFullPath.cpp:95
SoGroup
The SoGroup class is a node which managed other node instances.
Definition SoGroup.h:40
SoGroup::replaceChild
virtual void replaceChild(int index, SoNode *newchild)
Definition SoGroup.cpp:849
SoInput
The SoInput class is an abstraction of file import functionality.
Definition SoInput.h:61
SoInput::openFile
virtual SbBool openFile(const char *fileName, SbBool okIfNotFound=FALSE)
Definition SoInput.cpp:507
SoNode
The SoNode class is the base class for nodes used in scene graphs.
Definition SoNode.h:56
SoPathList
The SoPathList class is a container for pointers to SoPath objects.
Definition SoPathList.h:40
SoSearchAction
The SoSearchAction class provides methods for searching through scene graphs.
Definition SoSearchAction.h:44
SoSearchAction::setType
void setType(const SoType type, const SbBool chkderived=TRUE)
Definition SoSearchAction.cpp:216
SoSearchAction::ALL
@ ALL
Definition SoSearchAction.h:56
SoSearchAction::reset
void reset(void)
Definition SoSearchAction.cpp:382
SoSearchAction::setSearchingAll
void setSearchingAll(const SbBool searchall)
Definition SoSearchAction.cpp:319
SoSearchAction::getPaths
SoPathList & getPaths(void)
Definition SoSearchAction.cpp:372
SoSearchAction::setInterest
void setInterest(const Interest interest)
Definition SoSearchAction.cpp:290
SoSeparator
The SoSeparator class is a state-preserving group node.
Definition SoSeparator.h:44
SoTexture2::SoTexture2
SoTexture2(void)
Definition SoTexture2.cpp:412
SoTexture2::filename
SoSFString filename
Definition SoTexture2.h:70
SoTexture2::getClassTypeId
static SoType getClassTypeId(void)
Definition SoTexture2.cpp:407

When working with Inventor files, one often wants to embed external texture image files into the Inventor files themselves. Here's a minimal, standalone example which shows how that can be accomplished by calling SoField::touch() on the SoTexture2::image fields before scene graph export:

#include <Inventor/SoDB.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTexture2.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/actions/SoWriteAction.h>
int
main(void)
{
if (argc == 1) {
fprintf(stderr,"Usage: %s <infile> > outfile.iv\n", argv[0]);
return -1;
}
SoDB::init();
// open the file (don't use stdin) to enable Coin to search for textures
// relative to the input file.
SoInput in;
if (!in.openFile(argv[1])) {
return -1;
}
SoSeparator * root = SoDB::readAll(&in);
if (!root) { exit(1); }
root->ref();
SoSearchAction searchaction;
searchaction.setType(SoTexture2::getClassTypeId());
searchaction.setSearchingAll(TRUE);
searchaction.setInterest(SoSearchAction::ALL);
searchaction.apply(root);
const SoPathList & pl = searchaction.getPaths();
for (int i=0; i < pl.getLength(); i++) {
SoFullPath * fp = (SoFullPath *)pl[i];
SoTexture2 * tex = (SoTexture2 *)fp->getTail();
assert(tex->getTypeId() == SoTexture2::getClassTypeId());
tex->image.touch();
}
SoWriteAction wa;
wa.apply(root);
root->unref();
return 0;
}
SoField::touch
virtual void touch(void)
Definition SoField.cpp:1427
SoTexture2::getTypeId
virtual SoType getTypeId(void) const
Definition SoTexture2.cpp:407
SoTexture2::image
SoSFImage image
Definition SoTexture2.h:71

Run the example by piping the iv-file you want to do texture embedding on from stdin, e.g. like this:

    $ ./test < input.iv

FILE FORMAT/DEFAULTS:

Texture2 {
filename ""
image 0 0 0
wrapS REPEAT
wrapT REPEAT
model MODULATE
blendColor 0 0 0
enableCompressedTexture FALSE
}
SoTexture2::model
SoSFEnum model
Definition SoTexture2.h:74
SoTexture2::REPEAT
@ REPEAT
Definition SoTexture2.h:66
SoTexture2::enableCompressedTexture
SoSFBool enableCompressedTexture
Definition SoTexture2.h:76
SoTexture2::blendColor
SoSFColor blendColor
Definition SoTexture2.h:75
SoTexture2::wrapT
SoSFEnum wrapT
Definition SoTexture2.h:73
SoTexture2::MODULATE
@ MODULATE
Definition SoTexture2.h:59
SoTexture2::wrapS
SoSFEnum wrapS
Definition SoTexture2.h:72

## Member Enumeration Documentation

## ◆ Model

enum SoTexture2::Model

Texture mapping model, for deciding how to "merge" the texture map with the object it is mapped onto.

Enumerator
MODULATE | Texture color is multiplied by the polygon color. The result will be Phong shaded (if light model is PHONG).
DECAL | Texture image overwrites polygon shading. Textured pixels will not be Phong shaded. Has undefined behaviour for grayscale and grayscale-alpha textures.
BLEND | This model is normally used with monochrome textures (i.e. textures with one or two components). The first component, the intensity, is then used to blend between the shaded color of the polygon and the SoTexture2::blendColor.
REPLACE | Texture image overwrites polygon shading. Textured pixels will not be Phong shaded. Supports grayscale and grayscale alpha textures. This feature requires OpenGL 1.1. MODULATE will be used if OpenGL version < 1.1 is detected. Please note that using this texture model will make your Inventor files incompatible with older versions of Coin and Inventor. You need Coin >= 2.2 or TGS Inventor 4.0 to load Inventor files that uses the REPLACE texture model. Since Coin 2.2 TGS Inventor 4.0

## ◆ Wrap

enum SoTexture2::Wrap

Enumeration of wrapping strategies which can be used when the texture map doesn't cover the full extent of the geometry.

Enumerator
REPEAT | Repeat texture when coordinate is not between 0 and 1.
CLAMP | Clamp coordinate between 0 and 1.

## Constructor & Destructor Documentation

## ◆ SoTexture2()

SoTexture2::SoTexture2 | ( | void |  | ) |

Constructor.

## ◆ ~SoTexture2()

SoTexture2::~SoTexture2 | ( |  | ) |
| protectedvirtual

Destructor. Frees up internal resources used to store texture image data.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoTexture2::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoTexture2::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoTexture.

## ◆ getFieldDataPtr()

const SoFieldData ** SoTexture2::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoTexture2::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoTexture.

## ◆ doAction()

void SoTexture2::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoTexture.

## ◆ GLRender()

void SoTexture2::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoTexture.

## ◆ callback()

void SoTexture2::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoTexture.

## ◆ rayPick()

void SoTexture2::rayPick | ( | SoRayPickAction * | action | ) |
| virtual

Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented from SoNode.

## ◆ readImage()

SbBool SoTexture2::readImage | ( | const SbString & | fname,
|  | int & | w,
|  | int & | h,
|  | int & | nc,
|  | unsigned char *& | bytes )
| static

Not implemented in Coin; should probably not have been public in the original SGI Open Inventor API. We'll consider to implement it if requested.

## ◆ readInstance()

SbBool SoTexture2::readInstance | ( | SoInput * | in,
|  | unsigned short | flags )
| protectedvirtual

This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

`TRUE` or `FALSE` is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning `FALSE`.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

## ◆ notify()

void SoTexture2::notify | ( | SoNotList * | l | ) |
| protectedvirtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

## ◆ getReadStatus()

int SoTexture2::getReadStatus | ( | void |  | ) |
| protected

Returns read status. 1 for success, 0 for failure.

## ◆ setReadStatus()

void SoTexture2::setReadStatus | ( | int | s | ) |
| protected

Sets read status.

See also
  getReadStatus()

## Member Data Documentation

## ◆ filename

SoSFString SoTexture2::filename

Texture filename, referring to a file on disk in a supported image bitmap format.

By default contains an empty string, which means the texture will be fetched from SoTexture2::image and not from disk. (Specify either this field or use SoTexture2::image, not both.)

FIXME: Section about simage is outdated.

For reading texture image files from disk, Coin uses the "simage" library from Kongsberg Oil & Gas Technologies. This library must be installed for it to be possible to load any image files at all.

The set of image formats you can actually read with the simage library depends on how the simage library was built, as simage is again dependent on a few other low level file import/export libraries (for instance for JPEG, GIF, TIFF and PNG support). To make sure all wanted formats are supported, you should build the simage library yourself.

The set of image formats guaranteed to be supported by simage is Targa (.tga), PIC (.pic), SGI RGB (.rgb, .bw) and XWD (.xwd).

For more information about the simage library, including download and build instructions, see the Coin repository.

## ◆ image

SoSFImage SoTexture2::image

Inline image data. Defaults to contain an empty image.

See documentation of the SoSFImage class for a very detailed description of how the format specification for the image data is laid out, and what different image formats for color textures, semi-transparent textures, grayscale textures, etc., are supported.

## ◆ wrapS

SoSFEnum SoTexture2::wrapS

Wrapping strategy for the S coordinate when the texture map is narrower than the object to map onto.

Default value is SoTexture2::REPEAT.

## ◆ wrapT

SoSFEnum SoTexture2::wrapT

Wrapping strategy for the T coordinate when the texture map is shorter than the object to map onto.

Default value is SoTexture2::REPEAT.

## ◆ model

SoSFEnum SoTexture2::model

Texture mapping model for how the texture map is "merged" with the polygon primitives it is applied to. Default value is SoTexture2::MODULATE.

## ◆ blendColor

SoSFColor SoTexture2::blendColor

Blend color. Used when SoTexture2::model is SoTexture2::BLEND.

Default color value is [0, 0, 0], black, which means no contribution to the blending is made.

## ◆ enableCompressedTexture

SoSFBool SoTexture2::enableCompressedTexture

Hint to Coin that compressed textures should be used if this is supported by the graphics hardware and OpenGL drivers. Using compressed textures usually reduces texture memory usage for a texture by 4-6 times.

Since
  Coin 2.4.2
  TGS Inventor 4.0

The documentation for this class was generated from the following files:

- SoTexture2.h
- SoTexture2.cpp